test_that("202012142242", {
  f <- 'x^2'
  x <- laplacian(f, var = c('x','y','z'))
  y <- "2"
  expect_equal(x,y)
})

test_that("202012142244", {
  f <- 'y^2*x^2'
  x <- laplacian(f, var = c('x','y'))
  y <- "y^2 * 2 + 2 * x^2"
  expect_equal(x,y)
})

test_that("202012142245", {
  f <- function(x,y) c(x^2*y^2, x^2)
  x <- laplacian(f, var = c(x=3,y=5))
  y <- array(c(68,2))
  expect_equal(x,y)
})

test_that("202012142246", {
  f <- function(x,y) array(rep(c(x^2*y^2, x^2), 3), dim = c(2,3))
  x <- laplacian(f, var = c(x=3,y=5))
  y <- array(rep(c(68,2), 3), dim = c(2,3))
  expect_equal(x,y)
})

test_that("202012142310", {
  f <- function(x) x^2
  x <- laplacian(f, var = 100, coordinates = "spherical")
  y <- 2
  expect_equal(x,y)
})

test_that("202012142311", {
  f.num <- function(x,y,z) array(rep(c(x^2*y*sin(z),z*y,x*z+y^2), 2), dim = c(2,3))
  f.sym <- array(rep(c('x^2*y*sin(z)','z*y','x*z+y^2'), 2), dim = c(2,3))
  x.num <- laplacian(f.num, var = c(x=2,y=3,z=4), coordinates = "spherical", accuracy = 4)
  x.sym <- laplacian(f.sym, var = c(x=2,y=3,z=4), coordinates = "spherical")
  expect_equal(x.num,x.sym)
})

test_that("202012142312", {
  f.num <- function(x,y,z) array(rep(c(x^2*y*sin(z),z*y,x*z+y^2), 2), dim = c(2,3))
  f.sym <- array(rep(c('x^2*y*sin(z)','z*y','x*z+y^2'), 2), dim = c(2,3))
  x.num <- laplacian(f.num, var = c(x=2,y=3,z=4), accuracy = 4)
  x.sym <- laplacian(f.sym, var = c(x=2,y=3,z=4))
  expect_equal(x.num,x.sym)
})

test_that("202012142312", {
  f.num <- function(x,y,z,extra) if(extra) array(rep(c(x^2*y*sin(z),z*y,x*z+y^2), 2), dim = c(2,3))
  f.sym <- array(rep(c('x^2*y*sin(z)','z*y','a*x*z+y^2'), 2), dim = c(2,3))
  x.num <- laplacian(f.num, var = c(x=2,y=3,z=4), accuracy = 4, params = list(extra = TRUE))
  x.sym <- laplacian(f.sym, var = c(x=2,y=3,z=4), params = list(a = 1))
  expect_equal(x.num,x.sym)
})

test_that("202012291912", {
  e <- 1:25
  names(e) <- letters[1:25]
  n <- matrix(e, nrow = 5)
  s <- matrix(names(e), nrow = 5)
  x <- mxtr(n) 
  y <- evaluate(mxtr(s), e)
  expect_equal(x, y)
})

test_that("202012291913", {
  e <- 1
  names(e) <- letters[1]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- mxtr(n) 
  y <- evaluate(mxtr(s), e)
  expect_equal(x, y)
})

test_that("202012062212", {
  x <- derivative(f = "sin(x)", var = "x")
  y <- array("cos(x)")
  expect_equal(x,y)
})

test_that("202012062213", {
  x <- derivative(f = "sin(x)", var = c("x" = 0))
  y <- array(1)
  expect_equal(x,y)
})

test_that("202012062214", {
  x <- derivative(f = "sin(x)", var = "x", order = 2)
  y <- array("-sin(x)")
  expect_equal(x,y)
})

test_that("202012062215", {
  f <- c("y*sin(x)", "x*cos(y)")
  x <- derivative(f = f, var = c("x","y"), order = 1)
  y <- matrix(c("y * cos(x)","cos(y)","sin(x)","-(x * sin(y))"), nrow = 2)
  expect_equal(x,y)
})

test_that("202012062216", {
  x <- derivative(f = "y^2*sin(x)", var = c("x","y"), order = c(1,2))
  y <- array("2 * cos(x)")
  expect_equal(x,y)
})

test_that("202012062217", {
  x <- derivative(f = "y^2*sin(x)", var = c("x","y"), order = c(x = 1, y = 2))
  y <- array("2 * cos(x)")
  expect_equal(x,y)
})

test_that("202012062218", {
  x <- derivative(f = "y^2*sin(x)", var = c("x","y"), order = c(x = 2, y = 1))
  y <- array("-(2 * y * sin(x))")
  expect_equal(x,y)
})

test_that("202012062219", {
  x <- derivative(f = "y^2*sin(x)", var = c(x = 1, y = 0), order = c(x = 2, y = 1))
  y <- array(0)
  expect_equal(x,y)
})

test_that("202012062220", {
  f <- array(c("x","x","y","y","y*sin(x)","x*cos(y)"), dim = c(2,3,1))
  x <- derivative(f = f, var = c("x", "y"), order = c(x = 1))
  y <- array(c("1","1","0","0","y * cos(x)","cos(y)"), dim = c(2,3,1))
  expect_equal(x,y)
})

test_that("202012062221", {
  f <- array(c("x","x","y","y","y*sin(x)","x*cos(y)"), dim = c(2,3,1))
  x <- derivative(f = f, var = c("x" = 0, "y" = 0), order = c(x = 1))
  y <- array(c(1,1,0,0,0,1), dim = c(2,3,1))
  expect_equal(x,y)
})

test_that("202012062222", {
  f <- array(c("x","x","y","y","y*sin(x)","x*cos(y)"), dim = c(2,3,1))
  x <- derivative(f = f, var = c("x", "y"), order = 1)
  y <- array(c("1","1","0","0","y * cos(x)","cos(y)","0","0","1","1","sin(x)","-(x * sin(y))"), dim = c(2,3,1,2))
  expect_equal(x,y)
})

test_that("202012101552", {
  f <- array(expression(x,x,y,y,y*sin(x),x*cos(y)), dim = c(2,3,1))
  x <- derivative(f = f, var = c("x", "y"), order = 1)
  y <- array(c("1","1","0","0","y * cos(x)","cos(y)","0","0","1","1","sin(x)","-(x * sin(y))"), dim = c(2,3,1,2))
  expect_equal(x,y)
})

test_that("202012062223", {
  f.sym <- array(c("x","x","y","y","y*sin(x)","x*cos(y)"), dim = c(2,3,1))
  f.num <- function(x, y) array(c(x,x,y,y,y*sin(x),x*cos(y)), dim = c(2,3,1))
  var <- c(x = 1, y = 2)
  x <- derivative(f = f.sym, var = var, order = 1)
  y <- derivative(f = f.num, var = var, order = 1)
  expect_equal(x,y)
})

test_that("202012062224", {
  f.sym <- array(c("x","x","y","y","y*sin(x)","x*cos(y)"), dim = c(2,3,1))
  f.num <- function(x, y, extra = TRUE) if(extra) return(array(c(x,x,y,y,y*sin(x),x*cos(y)), dim = c(2,3,1)))
  var <- c(x = 1, y = 2)
  x <- derivative(f = f.sym, var = var, order = 1)
  y <- derivative(f = f.num, var = var, order = 1)
  expect_equal(x,y)
})

test_that("202012062225", {
  f.sym <- "x^3*exp(y)"
  f.num <- function(x, y, extra) if(!extra) return(x^3*exp(y))
  var <- c(x = 1, y = 2)
  x <- derivative(f = f.sym, var = var, order = 1)
  y <- derivative(f = f.num, var = var, order = 1, params = list(extra = FALSE))
  expect_equal(x,y)
})

test_that("202012062226", {
  f.sym <- "x^3*exp(y)"
  f.num <- function(x, y, extra) if(!extra) return(x^3*exp(y))
  var <- c(x = 1, y = 2)
  x <- derivative(f = f.sym, var = var, order = c(x = 1))
  y <- derivative(f = f.num, var = var, order = c(x = 1), params = list(extra = FALSE))
  expect_equal(x,y)
})

test_that("202012101605", {
  f.sym <- "x^3*exp(y)"
  var <- c(x = 1, y = 2)
  x <- derivative(f = f.sym, var = var, order = c(x = 1, y = 2))
  y <- derivative(f = f.sym, var = var, order = c(y = 2, x = 1))
  expect_equal(x,y)
})

test_that("202012111312", {
  x <- derivative(sum, 1:100)
  y <- matrix(1, ncol = 100, nrow = 1)
  expect_equal(x,y)
})

test_that("202012111314", {
  x <- derivative(prod, 1:10)
  y <- matrix(sapply(1:10, function(i) prod(c(1:10)[-i])), nrow = 1)
  expect_equal(x,y)
})

test_that("202012111503", {
  f <- function(x, y, z) matrix(c(x^3*y^2*z, 2*x^2*y, 3*x^2*y, 4*x^2*y), nrow = 2)
  x <- derivative(f, var = c(x = 1, y = 2, z = 3), order = c(y = 1, x = 2))
  y <- matrix(c(72, 4, 6, 8), nrow = 2)
  expect_equal(x,y)
})

test_that("202012111621", {
  f <- function(x, y) x^2*exp(y)
  x <- derivative(f, var = c(x = 1, y = 0), order = 2, accuracy = 4)
  y <- matrix(c(2, 1), ncol = 2)
  expect_equal(x,y)
})

test_that("202012111623", {
  f <- function(x) x
  x <- derivative(f, 1, order = 0)
  y <- array(1)
  expect_equal(x,y)
})

test_that("202012111658", {
  f <- function(x) x
  x <- derivative(f, 1:3, order = 0)
  y <- matrix(1:3, nrow = 3, ncol = 3)
  expect_equal(x,y)
})

test_that("202012302318", {
  f <- "a*x"
  x <- derivative(f, c(x=0), order = 1, params = list(a=3))
  y <- array(3)
  expect_equal(x,y)
})

test_that("202012291914", {
  set.seed(123)
  e <- runif(25)
  names(e) <- letters[1:length(e)]
  n <- matrix(e, nrow = 5)
  s <- matrix(names(e), nrow = 5)
  x <- det(n) 
  y <- evaluate(mxdet(s), e)
  expect_equal(x, y)
})

test_that("202012291915", {
  set.seed(123)
  e <- runif(25)
  names(e) <- letters[1:length(e)]
  n <- matrix(e, nrow = 5)
  s <- matrix(names(e), nrow = 5)
  x <- mxdet(n) 
  y <- evaluate(mxdet(s), e)
  expect_equal(x, y)
})

test_that("202012291916", {
  set.seed(123)
  e <- runif(4)
  names(e) <- letters[1:4]
  n <- matrix(e, nrow = 2)
  s <- matrix(names(e), nrow = 2)
  x <- mxdet(n) 
  y <- evaluate(mxdet(s), e)
  expect_equal(x, y)
})

test_that("202012291917", {
  set.seed(123)
  e <- runif(1)
  names(e) <- letters[1]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- mxdet(n) 
  y <- evaluate(mxdet(s), e)
  expect_equal(x, y)
})

test_that("202012291904", {
  e <- 1:26
  names(e) <- letters[1:26]
  n <- matrix(e, nrow = 2)
  s <- matrix(names(e), nrow = 2)
  x <- n %*% t(n) 
  y <- evaluate(s %mx% t(s), e)
  expect_equal(x, y)
})

test_that("202012291905", {
  e <- 1:26
  names(e) <- letters[1:26]
  n <- matrix(e, nrow = 2)
  s <- matrix(names(e), nrow = 2)
  x <- n %mx% t(n) 
  y <- evaluate(s %mx% t(s), e)
  expect_equal(x, y)
})

test_that("202012291906", {
  e <- 1:26
  names(e) <- letters[1:26]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- n %*% t(n) 
  y <- evaluate(s %mx% t(s), e)
  expect_equal(x, y)
})

test_that("202012291907", {
  e <- 1:26
  names(e) <- letters[1:26]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- n %mx% t(n) 
  y <- evaluate(s %mx% t(s), e)
  expect_equal(x, y)
})

test_that("202012291908", {
  e <- 1
  names(e) <- letters[1]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- n %*% t(n) 
  y <- evaluate(s %mx% t(s), e)
  expect_equal(x, y)
})

test_that("202012291909", {
  e <- 1
  names(e) <- letters[1]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- n %mx% t(n) 
  y <- evaluate(s %mx% t(s), e)
  expect_equal(x, y)
})

test_that("202012291918", {
  set.seed(123)
  e <- runif(25)
  names(e) <- letters[1:length(e)]
  n <- matrix(e, nrow = 5)
  s <- matrix(names(e), nrow = 5)
  x <- solve(n) 
  y <- evaluate(mxinv(s), e)
  expect_equal(x, y)
})

test_that("202012291919", {
  set.seed(123)
  e <- runif(25)
  names(e) <- letters[1:length(e)]
  n <- matrix(e, nrow = 5)
  s <- matrix(names(e), nrow = 5)
  x <- mxinv(n) 
  y <- evaluate(mxinv(s), e)
  expect_equal(x, y)
})

test_that("202012291920", {
  set.seed(123)
  e <- runif(4)
  names(e) <- letters[1:4]
  n <- matrix(e, nrow = 2)
  s <- matrix(names(e), nrow = 2)
  x <- mxinv(n) 
  y <- evaluate(mxinv(s), e)
  expect_equal(x, y)
})

test_that("202012291921", {
  set.seed(123)
  e <- runif(1)
  names(e) <- letters[1]
  n <- matrix(e, nrow = 1)
  s <- matrix(names(e), nrow = 1)
  x <- mxinv(n) 
  y <- evaluate(mxinv(s), e)
  expect_equal(x, y)
})

test_that("202012081602", {
  expect_equal(evaluate(array('x'), c(x = 1)), array(1))
})

test_that("202012081603", {
  expect_equal(evaluate(expression(x), c(x = 1)), 1)
})

test_that("202012081604", {
  x <- array(letters[1:4], dim = c(2,2))
  e <- data.frame(a = 1:3, b = 2, c = 3, d = 4)
  x <- evaluate(x, e)
  y <- array(c(1:3,2,2,2,3,3,3,4,4,4), dim = c(3,4))
  expect_equal(x,y)
})

test_that("202012081605", {
  expect_equal(evaluate(expression(x), data.frame(x = 1)), matrix(1))
})

test_that("202012311145", {
  f <- "a*myf(x)"
  myf <- function(x) if(x>0) 1 else -1
  var <- data.frame(a = 1:3, x = -1:1)
  x <- evaluate(f, var, params = list(myf = myf), vectorize = FALSE)
  y <- matrix(c(-1, -2, 3), ncol = 1)
  expect_equal(x,y)
})

test_that("202012272202", {
  f <- "x"
  x <- integral(f, bounds = list(x = c(0,1)))
  y <- 0.5
  expect_equal(x$value, y)
})

test_that("202012272203", {
  f <- "x"
  x <- integral(f, bounds = list(x = c(1,0)))
  y <- -0.5
  expect_equal(x$value, y)
})

test_that("202012272204", {
  f <- function(x) x
  x <- integral(f, bounds = list(x = c(1,0)))
  y <- -0.5
  expect_equal(x$value, y)
})

test_that("202012272205", {
  f <- function(x) x
  x <- integral(f, bounds = list(x = c(1,0)), vectorize = TRUE)
  y <- -0.5
  expect_equal(x$value, y)
})

test_that("202012272206", {
  f <- function(x) c(x, x^2)
  x <- integral(f, bounds = list(x = c(0,1)))
  y <- c(0.5, 1/3)
  expect_equal(x$value, y)
})

test_that("202012272207", {
  f <- function(x) c(x, x^2)
  x <- integral(f, bounds = list(x = c(0,1)), vectorize = TRUE)
  y <- c(0.5, 1/3)
  expect_equal(x$value, y)
})

test_that("202012272208", {
  f <- function(x) array(c(x, x^2))
  x <- integral(f, bounds = list(x = c(0,1)), drop = FALSE)
  y <- array(c(0.5, 1/3))
  expect_equal(x$value, y)
})

test_that("202012272209", {
  f <- array(c('x', 'x^2'))
  x <- integral(f, bounds = list(x = c(0,1)), drop = FALSE)
  y <- array(c(0.5, 1/3))
  expect_equal(x$value, y)
})

test_that("202012272210", {
  f <- function(x) array(c(x, x, x^2, x/2), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1)))
  y <- array(c(0.5, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y)
})

test_that("202012272211", {
  f <- array(c('x', 'x', 'x^2', 'x/2'), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1)))
  y <- array(c(0.5, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y)
})

test_that("202012272212", {
  f <- function(x, extra) if(extra) array(c(x, x, x^2, x/2), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1), extra = TRUE))
  y <- array(c(0.5, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y)
})

test_that("202012272213", {
  f <- array(c('x*y', 'x', 'x^2', 'x/2'), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1), y = c(0,1)))
  y <- array(c(0.25, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y)
})

test_that("202012272214", {
  f <- 1
  x <- integral(f, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar")
  y <- pi*2^2
  expect_equal(x$value, y)
})

test_that("202012272214", {
  f <- function(x, theta) 1
  x <- integral(f, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar")
  y <- pi*2^2
  expect_equal(x$value, y)
})

test_that("202012272215", {
  f.num <- function(x, theta) x*theta
  f.sym <- 'x*theta'
  x.num <- integral(f.num, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar")
  x.sym <- integral(f.sym, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar")
  expect_equal(x.num$value, x.sym$value)
})

test_that("202012272216", {
  f <- 1
  x <- integral(f, bounds = list(x = c(0,2), theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical")
  y <- 4/3*pi*2^3
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272217", {
  f <- 1
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical")
  y <- 4*pi*2^2
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272218", {
  f <- function(x, theta, phi) 1
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical")
  y <- 4*pi*2^2
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272218", {
  f <- function(x, theta, phi) 1
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", vectorize = TRUE)
  y <- 4*pi*2^2
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272219", {
  f <- function(x, theta, phi) c(1, 2)
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical")
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272220", {
  f <- function(x, theta, phi) rep(c(1, 2), each = length(theta))
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", vectorize = TRUE)
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272221", {
  f <- c(1, 2)
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", vectorize = TRUE)
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = abs(max(x$error/x$value)))
})

test_that("202012272222", {
  set.seed(123)
  f <- "x"
  x <- integral(f, bounds = list(x = c(0,1)), relTol = 1e-2, method = "mc")
  y <- 0.5
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272223", {
  set.seed(123)
  f <- "x"
  x <- integral(f, bounds = list(x = c(1,0)), relTol = 1e-2, method = "mc")
  y <- -0.5
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272224", {
  set.seed(123)
  f <- function(x) x
  x <- integral(f, bounds = list(x = c(1,0)), relTol = 1e-2, method = "mc")
  y <- -0.5
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272225", {
  set.seed(123)
  f <- function(x) x
  x <- integral(f, bounds = list(x = c(1,0)), relTol = 1e-2, method = "mc", vectorize = TRUE)
  y <- -0.5
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272226", {
  set.seed(123)
  f <- function(x) c(x, x^2)
  x <- integral(f, bounds = list(x = c(0,1)), relTol = 1e-2, method = "mc")
  y <- c(0.5, 1/3)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272227", {
  set.seed(123)
  f <- function(x) c(x, x^2)
  x <- integral(f, bounds = list(x = c(0,1)), relTol = 1e-2, method = "mc", vectorize = TRUE)
  y <- c(0.5, 1/3)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272228", {
  set.seed(123)
  f <- function(x) array(c(x, x^2))
  x <- integral(f, bounds = list(x = c(0,1)), drop = FALSE, relTol = 1e-2, method = "mc")
  y <- array(c(0.5, 1/3))
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272229", {
  set.seed(123)
  f <- array(c('x', 'x^2'))
  x <- integral(f, bounds = list(x = c(0,1)), drop = FALSE, relTol = 1e-2, method = "mc")
  y <- array(c(0.5, 1/3))
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272230", {
  set.seed(123)
  f <- function(x) array(c(x, x, x^2, x/2), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1)), relTol = 1e-2, method = "mc")
  y <- array(c(0.5, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272231", {
  set.seed(123)
  f <- array(c('x', 'x', 'x^2', 'x/2'), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1)), relTol = 1e-2, method = "mc")
  y <- array(c(0.5, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272232", {
  set.seed(123)
  f <- function(x, extra) if(extra) array(c(x, x, x^2, x/2), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1), extra = TRUE), relTol = 1e-2, method = "mc")
  y <- array(c(0.5, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272233", {
  set.seed(123)
  f <- array(c('x*y', 'x', 'x^2', 'x/2'), dim = c(2,2))
  x <- integral(f, bounds = list(x = c(0,1), y = c(0,1)), relTol = 1e-2, method = "mc")
  y <- array(c(0.25, 0.5, 1/3, 0.25), dim = c(2,2))
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272234", {
  set.seed(123)
  f <- 1
  x <- integral(f, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar", relTol = 1e-2, method = "mc")
  y <- pi*2^2
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272235", {
  set.seed(123)
  f <- function(x, theta) 1
  x <- integral(f, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar", relTol = 1e-2, method = "mc")
  y <- pi*2^2
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272236", {
  set.seed(123)
  f.num <- function(x, theta) x*theta
  f.sym <- 'x*theta'
  x.num <- integral(f.num, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar", relTol = 1e-2, method = "mc")
  x.sym <- integral(f.sym, bounds = list(x = c(0,2), theta = c(0,2*pi)), coordinates = "polar", relTol = 1e-2, method = "mc")
  expect_equal(x.num$value, x.sym$value, tolerance = 3*abs(max(x.num$error/x.num$value)))
})

test_that("202012272237", {
  set.seed(123)
  f <- 1
  x <- integral(f, bounds = list(x = c(0,2), theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc")
  y <- 4/3*pi*2^3
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272238", {
  set.seed(123)
  f <- 1
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc")
  y <- 4*pi*2^2
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272239", {
  set.seed(123)
  f <- function(x, theta, phi) 1
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc")
  y <- 4*pi*2^2
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272240", {
  set.seed(123)
  f <- function(x, theta, phi) 1
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc", vectorize = TRUE)
  y <- 4*pi*2^2
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272241", {
  set.seed(123)
  f <- function(x, theta, phi) c(1, 2)
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc")
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272242", {
  set.seed(123)
  f <- function(x, theta, phi) rep(c(1, 2), each = length(theta))
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc", vectorize = TRUE)
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012272243", {
  set.seed(123)
  f <- c(1, 2)
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), coordinates = "spherical", relTol = 1e-2, method = "mc", vectorize = TRUE)
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012310003", {
  set.seed(123)
  f <- c(1, "2*a")
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), params = list(a = 1), coordinates = "spherical", relTol = 1e-2, method = "mc", vectorize = TRUE)
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012310004", {
  set.seed(123)
  f <- c(1, "2*a")
  x <- integral(f, bounds = list(x = 2, theta = c(0,pi), phi = c(0,2*pi)), params = list(a = 1), coordinates = "spherical", relTol = 1e-2, vectorize = TRUE)
  y <- c(4*pi*2^2, 8*pi*2^2)
  expect_equal(x$value, y, tolerance = 3*abs(max(x$error/x$value)))
})

test_that("202012141334", {
  f <- c('x^2','y^3','z^4')
  x <- divergence(f, var = c('x','y','z'))
  y <- "2 * x + 3 * y^2 + 4 * z^3"
  expect_equal(x,y)
})

test_that("202012141335", {
  f <- c('x^2','y^3','z^4')
  x <- divergence(f, var = c('x','y','z'), drop = FALSE)
  y <- array("2 * x + 3 * y^2 + 4 * z^3")
  expect_equal(x,y)
})

test_that("202012141336", {
  f <- array(rep(c('x^2','y^3','z^4'), each = 2), dim = c(2,3))
  x <- divergence(f, var = c('x','y','z'))
  y <- array("2 * x + 3 * y^2 + 4 * z^3", dim = 2)
  expect_equal(x,y)
})

test_that("202012141345", {
  f <- function(x, y, z) c(x^2, y^3, z^4)
  x <- divergence(f, var = c('x' = 1, 'y' = 2, 'z' = 3))
  y <- 122
  expect_equal(x,y)
})

test_that("202012141346", {
  f <- function(x, y, z) c(x^2, y^3, z^4)
  x <- divergence(f, var = c('y' = 2, 'z' = 3, 'x' = 1))
  y <- 0
  expect_equal(x,y)
})

test_that("202012141351", {
  f <- function(x) c(x[1]^2, x[2]^3, x[3]^4)
  x <- divergence(f, var = c(1, 2, 3))
  y <- 122
  expect_equal(x,y)
})

test_that("202012141352", {
  f <- function(x) c(x[1]^2, x[2]^3, x[3]^4)
  x <- divergence(f, var = c(2, 3, 1))
  y <- 35
  expect_equal(x,y)
})

test_that("202012141353", {
  f <- c("r^3","r*z","r*z*sin(phi)")
  x <- divergence(f, var = c('r'=10,'phi'=pi/6,'z'=Inf), coordinates = 'cylindrical')
  y <- 405
  expect_equal(x,y)
})

test_that("202012141410", {
  f <- function(r, phi, z) c(r^3,r*z,r*z*sin(phi))
  x <- divergence(f, var = c('r'=10,'phi'=pi/6,'z'=100), coordinates = 'cylindrical')
  y <- 405
  expect_equal(x,y)
})

test_that("202012141411", {
  f <- function(x) c(x[1]^3,x[1]*x[3],x[1]*x[3]*sin(x[2]))
  x <- divergence(f, var = c(10,pi/6,100), coordinates = 'cylindrical')
  y <- 405
  expect_equal(x,y)
})

test_that("202012141412", {
  f <- function(r, phi, z, extra) if(extra) c(r^3,r*z,r*z*sin(phi))
  x <- divergence(f, var = c('r'=10,'phi'=pi/6,'z'=100), coordinates = 'cylindrical', params = list(extra = TRUE))
  y <- 405
  expect_equal(x,y)
})

test_that("202012141625", {
  f <- function(x, extra) if(extra) array(1:6*rep(c(x[1]^3,x[1]*x[3],x[1]*x[3]*sin(x[2])), each = 6), dim = c(1,3,2,3))
  x <- divergence(f, var = c(10,pi/6,100), coordinates = 'cylindrical', params = list(extra = TRUE))
  y <- 405*array(1:6, dim = c(1,3,2))
  expect_equal(x,y)
})

test_that("202012141633", {
  f <- c('0', 'r^-2', 'k')
  x <- divergence(f, var = c('r','phi','z'), coordinates = 'cylindrical')
  y <- "0"
  expect_equal(x,y)
})

test_that("202012141647", {
  f <- c('r*cos(phi)', '-r*sin(phi)', 'r*z')
  x <- divergence(f, var = c('r'=12,'phi'=pi/3,'z'=Inf), coordinates = 'cylindrical')
  y <- 12.5
  expect_equal(x,y)
})

test_that("202012141704", {
  f <- array(c('r','r^2*sin(theta)','r*sin(theta)','0','0','r^2*sin(phi)','0','0','r*cos(theta)'), dim = c(3,3))
  x <- divergence(f, var = c('r'=10,'theta'=20,'phi'=30), coordinates = 'spherical')
  y <- function(r,theta,phi) array(c(3, 4*r*sin(theta), 3*sin(theta) + r*cos(theta)/sin(theta)*sin(phi)))
  expect_equal(x,y(10,20,30))
})

test_that("202012141704", {
  f <- function(x) x
  x <- divergence(f, 1:100)
  y <- 100
  expect_equal(x,y)
})

test_that("202012142259", {
  f <- function(x) x
  x <- divergence(f, 1, coordinates = "spherical")
  y <- 1
  expect_equal(x,y)
})

test_that("202012302353", {
  f <- c('a*x^2', 'y^3', 'z^4')
  x <- divergence(f, var = c('x' = 1, 'y' = 2, 'z' = 3), params = list(a = 1))
  y <- 122
  expect_equal(x,y)
})

test_that("202012131411", {
  x <- gradient(f = "sin(x)", var = "x")
  y <- "cos(x)"
  expect_equal(x,y)
})

test_that("202012131510", {
  x <- gradient(f = "sin(x)", var = "x", drop = FALSE)
  y <- array("cos(x)", dim = c(1,1))
  expect_equal(x,y)
})

test_that("202012131412", {
  x <- "sin(x)" %gradient% "x"
  y <- "cos(x)"
  expect_equal(x,y)
})

test_that("202012131413", {
  x <- gradient(f = "sin(x)", var = c("x" = 0))
  y <- 1
  expect_equal(x,y)
})

test_that("202012131414", {
  x <- "sin(x)" %gradient% c(x=0)
  y <- 1
  expect_equal(x,y)
})

test_that("202012131415", {
  x <- gradient(f = "y*sin(x)", var = c("x","y"))
  y <- c("y * cos(x)", "sin(x)")
  expect_equal(x,y)
})

test_that("202012131416", {
  f <- c("y*sin(x)", "x*cos(y)")
  x <- gradient(f = f, var = c("x","y"))
  y <- array(c("y * cos(x)", "cos(y)", "sin(x)", "-(x * sin(y))"), dim = c(2,2))
  expect_equal(x,y)
})

test_that("202012131417", {
  f.num <- function(x, y) c(y*sin(x), x*cos(y))
  f.sym <- c("y*sin(x)", "x*cos(y)")
  var <- c(x=-pi, y=-13)
  x <- gradient(f = f.num, var = var)
  y <- gradient(f = f.sym, var = var)
  expect_equal(x,y)
})

test_that("202012131418", {
  x <- gradient('r*theta*phi', var = c('r','theta','phi'), coordinates = 'spherical')
  y <- c("1/1 * (theta * phi)", "1/r * (r * phi)", "1/(r*sin(theta)) * (r * theta)")
  expect_equal(x,y)
})

test_that("202012131418", {
  f.num <- function(r, theta, phi) rep(r*theta*phi, 2)
  f.sym <- rep("r*theta*phi", 2)
  var <- c(r = 100, theta = 52, phi = pi/3)
  x <- gradient(f.num, var = var, coordinates = 'spherical')
  y <- gradient(f.sym, var = var, coordinates = 'spherical')
  expect_equal(x,y)
})

test_that("202012131807", {
  f.num <- function(x) rep(prod(x), 2)
  f.sym <- rep("r*theta*phi", 2)
  x <- gradient(f.num, var = c(100, 52, pi/3), coordinates = 'spherical')
  y <- gradient(f.sym, var = c(r = 100, theta = 52, phi = pi/3), coordinates = 'spherical')
  expect_equal(x,y)
})

test_that("202012131919", {
  f <- function(x, y) array(x^2*y^2, dim = c(1,1,1))
  x <- gradient(f, var = c('x' = 2,'y' = 3))
  y <- c(36, 24)
  expect_equal(x,y)
})

test_that("202012131920", {
  f <- function(x, y) array(x^2*y^2, dim = c(1,1,1))
  x <- gradient(f, var = c('x' = 2,'y' = 3), drop = FALSE)
  y <- array(c(36, 24), dim = c(1,1,1,2))
  expect_equal(x,y)
})

test_that("202012141708", {
  f <- function(x, y, extra) if(extra) array(x^2*y^2, dim = c(1,1,1))
  x <- gradient(f, var = c('x' = 2,'y' = 3), drop = FALSE, params = list(extra = TRUE))
  y <- array(c(36, 24), dim = c(1,1,1,2))
  expect_equal(x,y)
})

test_that("202012141709", {
  f.num <- function(x, extra) if(extra) rep(prod(x), 2)
  f.sym <- rep("r*theta*phi", 2)
  x <- gradient(f.num, var = c(100, 52, pi/3), coordinates = 'spherical', params = list(extra = TRUE))
  y <- gradient(f.sym, var = c(r = 100, theta = 52, phi = pi/3), coordinates = 'spherical')
  expect_equal(x,y)
})

test_that("202012302347", {
  x <- gradient(f = "a*sin(x)", var = c("x"=0), params = list(a = 10))
  y <- 10
  expect_equal(x,y)
})
